using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using UsbLibrary;

namespace UsbApp
{
    public partial class usbscope : Form
    {

                           
        
        



        int cis1, cis2, cis3;
        int c_out, scr1, scr2,scr3;

      
        byte[] pom1={2};

      

       

        public usbscope()
        {
            InitializeComponent();

            this.usb.ProductId = 0x05df;
            this.usb.VendorId = 0x16c0;
        }

        private void usb_OnDeviceArrived(object sender, EventArgs e)
        {
           toolStripStatusLabel1.Text  = "Found HID Device";
        }

        private void usb_OnDeviceRemoved(object sender, EventArgs e)
        {
            if (InvokeRequired)
            {
                Invoke(new EventHandler(usb_OnDeviceRemoved), new object[] { sender, e });
            }
            else
            {
                toolStripStatusLabel1.Text = "Device removed";
            }
        }

        private void usb_OnSpecifiedDeviceArrived(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "Found HID Device";
        }

        private void usb_OnSpecifiedDeviceRemoved(object sender, EventArgs e)
        {
            if (InvokeRequired)
            {
                Invoke(new EventHandler(usb_OnSpecifiedDeviceRemoved), new object[] { sender, e });
            }
            else
            {
                toolStripStatusLabel1.Text = "Device removed";
            }
        }

        protected override void OnHandleCreated(EventArgs e)
        {
            base.OnHandleCreated(e);
            usb.RegisterHandle(Handle);
        }
        
        protected override void WndProc(ref Message m)
        {
            usb.ParseMessages(ref m);
            base.WndProc(ref m);	// pass message on to base form
        }


        private void usb_OnDataRecieved(object sender, DataRecievedEventArgs args)
        {
            if (InvokeRequired)
            {
                try
                {
                    Invoke(new DataRecievedEventHandler(usb_OnDataRecieved), new object[] { sender, args });
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            else
                
                    cis1 = (int)args.data[1];
                    cis2 = (int)args.data[2];
                    cis3 = (int)args.data[3];
                    label2.Text = cis1.ToString();
                    label3.Text = cis2.ToString();
                    label7.Text = cis3.ToString();
                    if (cis1 == 1)
                    {   if (Math.Abs(cis2-scr1)<4)
                        {   pom1 = BitConverter.GetBytes(1);
                            try
                            {usb.SpecifiedDevice.SendData(pom1);}
                            catch { }
                        }
                    }
                    if (cis1 == 2)
                    {
                        if (Math.Abs(cis2 - scr2) < 4)
                        {
                            pom1 = BitConverter.GetBytes(1);
                            try
                            { usb.SpecifiedDevice.SendData(pom1); }
                            catch { }
                        }
                    }
                    if (cis1 == 3)
                    {
                        if (Math.Abs(cis2 - scr3) < 4)
                        {
                            pom1 = BitConverter.GetBytes(1);
                            try
                            { usb.SpecifiedDevice.SendData(pom1); }
                            catch { }
                        }
                    }
            
        }


        private void button1_Click(object sender, EventArgs e)
        
        {
            string cisla;
            
            cisla = textBox1.Text;
            try
            {
                c_out = Convert.ToInt32(cisla);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
                        
            
            if (c_out > 254)
                c_out = 2;
            if (c_out < 1)
                c_out = 1;

            pom1 = BitConverter.GetBytes(c_out);
            try
            {
                usb.SpecifiedDevice.SendData(pom1);
            }
            catch {}
             
             label8.Text = BitConverter.ToString(pom1, 0, 1);
        }

        

       

        private void statusStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void usb_OnDataSend(object sender, EventArgs e)
        {
            button1.Text = "Poslano";
        }

        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            
            scr1 = hScrollBar1.Value;
            label9.Text = scr1.ToString();
        }

        private void hScrollBar2_Scroll(object sender, ScrollEventArgs e)
        {
            scr2 = hScrollBar2.Value;
            label10.Text = scr2.ToString();
        }

        private void hScrollBar3_Scroll(object sender, ScrollEventArgs e)
        {
            scr3 = hScrollBar3.Value;
            label11.Text = scr3.ToString();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
        
        
  
    }
}